*** a/src/bin/pg_dump/pg_dump.c
--- b/src/bin/pg_dump/pg_dump.c
***************
*** 1133,1146 **** selectDumpableTable(TableInfo *tbinfo)
  							   tbinfo->dobj.catId.oid))
  		tbinfo->dobj.dump = false;
  
- 	/* If table is to be dumped, check that the data is not excluded */
- 	if (tbinfo->dobj.dump && !
- 		simple_oid_list_member(&tabledata_exclude_oids,
- 							   tbinfo->dobj.catId.oid))
- 		tbinfo->dobj.dumpdata = true;
- 	else
- 		tbinfo->dobj.dumpdata = false;
- 
  }
  
  /*
--- 1133,1138 ----
***************
*** 1581,1587 **** dumpTableData(Archive *fout, TableDataInfo *tdinfo)
  	char	   *copyStmt;
  
  	/* don't do anything if the data isn't wanted */
! 	if (!tbinfo->dobj.dumpdata)
  		return;
  
  	if (!dump_inserts)
--- 1573,1579 ----
  	char	   *copyStmt;
  
  	/* don't do anything if the data isn't wanted */
! 	if (!tdinfo->dobj.dump)
  		return;
  
  	if (!dump_inserts)
***************
*** 1670,1675 **** makeTableDataInfo(TableInfo *tbinfo, bool oids)
--- 1662,1674 ----
  	tdinfo->filtercond = NULL;	/* might get set later */
  	addObjectDependency(&tdinfo->dobj, tbinfo->dobj.dumpId);
  
+ 	/* Check that the data is not explicitly excluded */
+ 	if (! simple_oid_list_member(&tabledata_exclude_oids,
+ 							   tbinfo->dobj.catId.oid))
+ 		tdinfo->dobj.dump = true;
+ 	else
+ 		tdinfo->dobj.dump = false;
+ 
  	tbinfo->dataObj = tdinfo;
  }
  
*** a/src/bin/pg_dump/pg_dump.h
--- b/src/bin/pg_dump/pg_dump.h
***************
*** 129,135 **** typedef struct _dumpableObject
  	char	   *name;			/* object name (should never be NULL) */
  	struct _namespaceInfo *namespace;	/* containing namespace, or NULL */
  	bool		dump;			/* true if we want to dump this object */
- 	bool        dumpdata;       /* true if we want data for this object */
  	bool		ext_member;		/* true if object is member of extension */
  	DumpId	   *dependencies;	/* dumpIds of objects this one depends on */
  	int			nDeps;			/* number of valid dependencies */
--- 129,134 ----
